/**
* @file Sedra models and related utility functions
* @version 1.2.0
* @author Greg Borota
* @copyright (c) 2017 Greg Borota.
* @license MIT
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*/
!function(e,r){"object"==typeof exports&&"undefined"!=typeof module?r(exports):"function"==typeof define&&define.amd?define(["exports"],r):r(e.sedraModel={})}(this,function(e){"use strict";var r=Object.freeze(["Normal","Parenthesized","Bracketed","HighFrequency"]),s=Object.freeze(["","a","o","e","i","u"]),l=Object.freeze(["","Singular","Plural"]),a=Object.freeze(["","Common","Masculine","Feminine"]),o=Object.freeze(["","Peal","Ethpeal","Pael","Ethpael","Aphel","Ettaphal","Shaphel","Eshtaphal","Saphel","Estaphal","Pauel","Ethpaual","Paiel","Ethpaial","Palpal","Ethpalpal","Palpel","Ethpalpal1","Pamel","Ethpamal","Parel","Ethparal","Pali","Ethpali","Pahli","Ethpahli","Taphel","Ethaphal"]),n=function(e,r){return Object.freeze(Object.create(null,{seyame:{value:e,enumerable:!0},rootType:{value:r,enumerable:!0}}))},u=function(e){return n(!!(1&e),r[(6&e)>>>1])},t=Object.freeze(["Verb","ParticipleAdjective","Denominative","Substantive","Noun","Pronoun","ProperNoun","Numeral","Adjective","Particle","Idiom","Adverb-)iTt","AdjectiveOfPlace","Adverb"]),v=Object.freeze(["","to)","To)","no)","ono)","iTno)","wuno)","tono)","twuno)","wuso)","oro)","qono)","yin"]),d=Object.freeze(["","oTo)","iTto)"]),m=Object.freeze(["","wuto)","o)iTt"]),i=Object.freeze(["","m","t","$"]),w=Object.freeze(["","Bi","Tri","FourRadical","FiveRadical","SixRadical","Compound"]),b=Object.freeze(["","Peal","Ethpeal","Pael","Ethpael","Aphel","Ettaphal","Shaphel","Eshtaphal","Saphel","Estaphal","P","Ethp","Palpel","Ethpalpal","Pamel"]),c=function(e,r,s,l){return Object.freeze(Object.create(null,{seyame:{value:e,enumerable:!0},wordType:{value:r,enumerable:!0},grammaticalCategory:{value:s,enumerable:!0},listing:{value:l,enumerable:!0}}))},h=function(e){return c(!!(1&e),r[(2&e)>>>1],t[(60&e)>>>2],!!(64&e>>>6))},f=function(e,r,s,l,a,o,n,u,t,v,d){return Object.freeze(Object.create(null,{firstSuffix:{value:e,enumerable:!0},secondSuffix:{value:r,enumerable:!0},thirdSuffix:{value:s,enumerable:!0},prefix:{value:l,enumerable:!0},firstVowel:{value:a,enumerable:!0},secondVowel:{value:o,enumerable:!0},thirdVowel:{value:n,enumerable:!0},fourthVowel:{value:u,enumerable:!0},vowelCount:{value:t,enumerable:!0},radicalType:{value:v,enumerable:!0},form:{value:d,enumerable:!0}}))},p=function(e){return f(v[15&e],d[(48&e)>>>4],m[(192&e)>>>6],i[(768&e)>>>8],s[(7168&e)>>>10],s[(57344&e)>>>13],s[(458752&e)>>>16],s[(3670016&e)>>>19],(29360128&e)>>>22,w[(234881024&e)>>>25],b[(4026531840&e)>>>28])},y=Object.freeze(["CommonOrNone","Masculine","Feminine"]),T=Object.freeze(["","Third","Second","First"]),g=Object.freeze(["SingularOrNone","Plural"]),x=Object.freeze(["","Suffix","Contraction"]),I=Object.freeze(["","Third","Second","First"]),O=Object.freeze(["","Absolute","Construct","Emphatic"]),j=Object.freeze(["","Perfect","Imperfect","Imperative","Infinitive","ActiveParticiple","PassiveParticiple","Participles"]),P=function(e,r,s,l){return Object.freeze(Object.create(null,{seyame:{value:e,enumerable:!0},listing:{value:r,enumerable:!0},enclitic:{value:s,enumerable:!0},lexeme:{value:l,enumerable:!0}}))},J=function(e){return P(!!(1&e),(30&e)>>>1,!!(32&e),!!(64&e))},z=function(e,r,s,l,a,o,n,u,t,v,d){return Object.freeze(Object.create(null,{suffixGender:{value:e,enumerable:!0},suffixPerson:{value:r,enumerable:!0},suffixNumber:{value:s,enumerable:!0},suffixType:{value:l,enumerable:!0},prefixCode:{value:a,enumerable:!0},gender:{value:o,enumerable:!0},person:{value:n,enumerable:!0},number:{value:u,enumerable:!0},state:{value:t,enumerable:!0},tense:{value:v,enumerable:!0},form:{value:d,enumerable:!0}}))},k=function(e){return z(y[(12&e)>>>2],T[(48&e)>>>4],g[(64&e)>>>6],x[(384&e)>>>7],(32256&e)>>>9,a[(98304&e)>>>15],I[(393216&e)>>>17],l[(1572864&e)>>>19],O[(6291456&e)>>>21],j[(58720256&e)>>>23],o[(4227858432&e)>>>26])},C=Object.freeze(["BeforeWord","AfterWord"]),S=Object.freeze(["Normal","Italic"]),E=Object.freeze(["None","Transitive","Intransitive"]),A=function(e,r,s,l,a,o,n,u){return Object.freeze(Object.create(null,{commentPosition:{value:e,enumerable:!0},commentFont:{value:r,enumerable:!0},stringBeforeFont:{value:s,enumerable:!0},stringAfterFont:{value:l,enumerable:!0},verbType:{value:a,enumerable:!0},number:{value:o,enumerable:!0},gender:{value:n,enumerable:!0},form:{value:u,enumerable:!0}}))},F=function(e){return A(C[(2&e)>>>1],S[(4&e)>>>2],S[(8&e)>>>3],S[(16&e)>>>4],E[(96&e)>>>5],l[(384&e)>>>7],a[(1536&e)>>>9],o[(63488&e)>>>11])},V=Object.freeze(["Syriac","Akkadian","Aramaic","Arabic","Armenian","Greek","Hebrew","Latin","Persian","Sanskrit"]),B=function(e,r){return Object.freeze(Object.create(null,{language:{value:e,enumerable:!0},wordType:{value:r,enumerable:!0}}))},N=function(e){return B(V[15&e],r[(16&e)>>>4])},q=Object.freeze(Object.create(null,{englishName:{enumerable:!0,get:function(){return this.english[0]}},englishShortName:{enumerable:!0,get:function(){return this.english[1]}}})),M=function(e,r,s,l,a,o){return Object.freeze(Object.create(q,{id:{value:e,enumerable:!0},peshittaId:{value:r,enumerable:!0},name:{value:s,enumerable:!0},vocalised:{value:l,enumerable:!0},english:{value:a,enumerable:!0},stats:{value:o,enumerable:!0}}))},R=M,L=[R(0,0,"","",["Old Testament","OT"]),R(1,0,"","",[]),R(2,0,"","",[]),R(3,0,"","",[]),R(4,0,"","",[]),R(5,0,"","",[]),R(6,0,"","",[]),R(7,0,"","",[]),R(8,0,"","",[]),R(9,0,"","",[]),R(10,0,"","",[]),R(11,0,"","",[]),R(12,0,"","",[]),R(13,0,"","",[]),R(14,0,"","",[]),R(15,0,"","",[]),R(16,0,"","",[]),R(17,0,"","",[]),R(18,0,"","",[]),R(19,0,"","",[]),R(20,0,"","",[]),R(21,0,"","",[]),R(22,0,"","",[]),R(23,0,"","",[]),R(24,0,"","",[]),R(25,0,"","",[]),R(26,0,"","",[]),R(27,0,"","",[]),R(28,0,"","",[]),R(29,0,"","",[]),R(30,0,"","",[]),R(31,0,"","",[]),R(32,0,"","",[]),R(33,0,"","",[]),R(34,0,"","",[]),R(35,0,"","",[]),R(36,0,"","",[]),R(37,0,"","",[]),R(38,0,"","",[]),R(39,0,"","",[]),R(40,0,"","",[]),R(41,0,"","",[]),R(42,0,"","",[]),R(43,0,"","",[]),R(44,0,"","",[]),R(45,0,"","",[]),R(46,0,"","",[]),R(47,0,"","",[]),R(48,0,"","",[]),R(49,0,"","",[]),R(50,50,"","",[]),R(51,51,"","",["New Testament","NT"],{books:27,chapters:260,verses:7958,words:109654}),R(52,52,"mty","mat'ay",["Matthew","Mt","Matt","Mat"],{chapters:28,verses:1071,words:13980,chapter:{1:{verses:25,words:290},2:{verses:23,words:335},3:{verses:17,words:239},4:{verses:25,words:317},5:{verses:48,words:621},6:{verses:34,words:486},7:{verses:29,words:365},8:{verses:34,words:451},9:{verses:38,words:470},10:{verses:42,words:547},11:{verses:30,words:379},12:{verses:50,words:675},13:{verses:58,words:788},14:{verses:36,words:428},15:{verses:39,words:490},16:{verses:28,words:397},17:{verses:27,words:389},18:{verses:35,words:513},19:{verses:30,words:453},20:{verses:34,words:440},21:{verses:46,words:672},22:{verses:46,words:490},23:{verses:39,words:513},24:{verses:51,words:595},25:{verses:46,words:589},26:{verses:75,words:983},27:{verses:66,words:799},28:{verses:20,words:266}}}),R(53,53,"mrqws","marqwOs",["Mark","Mk","Mrk","Mar","Mr"],{chapters:16,verses:678,words:8793,chapter:{1:{verses:45,words:511},2:{verses:28,words:400},3:{verses:35,words:380},4:{verses:41,words:517},5:{verses:43,words:531},6:{verses:56,words:766},7:{verses:37,words:476},8:{verses:38,words:494},9:{verses:50,words:695},10:{verses:52,words:702},11:{verses:33,words:467},12:{verses:44,words:628},13:{verses:37,words:485},14:{verses:72,words:945},15:{verses:47,words:546},16:{verses:20,words:250}}}),R(54,54,"lwq)","lwuqo)",["Luke","Lk","Luk"],{chapters:24,verses:1151,words:15234,chapter:{1:{verses:80,words:831},2:{verses:52,words:625},3:{verses:38,words:494},4:{verses:44,words:582},5:{verses:39,words:567},6:{verses:49,words:703},7:{verses:50,words:716},8:{verses:56,words:866},9:{verses:62,words:877},10:{verses:42,words:606},11:{verses:54,words:797},12:{verses:59,words:825},13:{verses:35,words:510},14:{verses:35,words:484},15:{verses:32,words:424},16:{verses:31,words:477},17:{verses:37,words:460},18:{verses:43,words:579},19:{verses:48,words:600},20:{verses:47,words:563},21:{verses:38,words:452},22:{verses:71,words:853},23:{verses:56,words:714},24:{verses:53,words:629}}}),R(55,55,"ywxnn","ywuxanon",["John","Jn","Joh","Jhn"],{chapters:21,verses:879,words:12409,chapter:{1:{verses:51,words:629},2:{verses:25,words:311},3:{verses:36,words:533},4:{verses:54,words:734},5:{verses:47,words:675},6:{verses:71,words:947},7:{verses:53,words:700},8:{verses:59,words:887},9:{verses:41,words:575},10:{verses:42,words:564},11:{verses:57,words:734},12:{verses:50,words:680},13:{verses:38,words:583},14:{verses:31,words:444},15:{verses:27,words:368},16:{verses:33,words:455},17:{verses:26,words:376},18:{verses:40,words:633},19:{verses:42,words:640},20:{verses:31,words:452},21:{verses:25,words:489}}}),R(56,56,"prksys","praksyis",["Acts","Ac","Act"],{chapters:28,verses:1007,words:15385,chapter:{1:{verses:26,words:414},2:{verses:47,words:633},3:{verses:26,words:378},4:{verses:37,words:544},5:{verses:42,words:646},6:{verses:15,words:213},7:{verses:60,words:862},8:{verses:40,words:590},9:{verses:43,words:670},10:{verses:48,words:712},11:{verses:30,words:416},12:{verses:25,words:412},13:{verses:52,words:744},14:{verses:28,words:420},15:{verses:41,words:565},16:{verses:40,words:620},17:{verses:34,words:609},18:{verses:28,words:457},19:{verses:41,words:672},20:{verses:38,words:558},21:{verses:40,words:651},22:{verses:30,words:471},23:{verses:35,words:541},24:{verses:27,words:421},25:{verses:27,words:450},26:{verses:32,words:522},27:{verses:44,words:676},28:{verses:31,words:518}}}),R(57,60,"r*hwmy)","r*h_wumoye)",["Romans","Ro","Rom","Rm"],{chapters:16,verses:433,words:5768,chapter:{1:{verses:32,words:424},2:{verses:29,words:407},3:{verses:31,words:324},4:{verses:25,words:326},5:{verses:21,words:317},6:{verses:23,words:293},7:{verses:25,words:390},8:{verses:39,words:518},9:{verses:33,words:432},10:{verses:21,words:260},11:{verses:36,words:501},12:{verses:21,words:271},13:{verses:14,words:234},14:{verses:23,words:336},15:{verses:33,words:412},16:{verses:27,words:323}}}),R(58,61,"). qwr*ynty)","). qwOr*yint,oye)",["1 Corinthians","1Co","1 Cor","1 Co","I Co","I Cor","I Corinthians","1Cor","1Corinthians","1st Corinthians","First Corinthians"],{chapters:16,verses:437,words:5987,chapter:{1:{verses:31,words:382},2:{verses:16,words:224},3:{verses:23,words:309},4:{verses:21,words:301},5:{verses:13,words:200},6:{verses:20,words:293},7:{verses:40,words:619},8:{verses:13,words:190},9:{verses:27,words:422},10:{verses:33,words:420},11:{verses:34,words:471},12:{verses:31,words:425},13:{verses:13,words:185},14:{verses:40,words:565},15:{verses:58,words:703},16:{verses:24,words:278}}}),R(59,62,"b. qwr*ynty)","b. qwOr*yint,oye)",["2 Corinthians","2Co","2 Cor","2 Co","II Co","II Cor","II Corinthians","2Cor","2Corinthians","2nd Corinthians","Second Corinthians"],{chapters:13,verses:257,words:3737,chapter:{1:{verses:24,words:356},2:{verses:17,words:230},3:{verses:18,words:248},4:{verses:18,words:259},5:{verses:21,words:286},6:{verses:18,words:221},7:{verses:16,words:275},8:{verses:24,words:316},9:{verses:15,words:223},10:{verses:18,words:273},11:{verses:33,words:466},12:{verses:21,words:369},13:{verses:14,words:215}}}),R(60,63,"glTy*)","goloToy*e)",["Galatians","Ga","Gal"],{chapters:6,verses:149,words:1940,chapter:{1:{verses:24,words:301},2:{verses:21,words:348},3:{verses:29,words:401},4:{verses:31,words:376},5:{verses:26,words:297},6:{verses:18,words:217}}}),R(61,64,")psy*)",")epEsy*e)",["Ephesians","Ep","Eph","Ephes"],{chapters:6,verses:155,words:1774,chapter:{1:{verses:23,words:257},2:{verses:22,words:267},3:{verses:21,words:223},4:{verses:32,words:357},5:{verses:33,words:379},6:{verses:24,words:291}}}),R(62,65,"pylypsy*)","pyilyipEsoy*e)",["Philippians","Pp","Phil","Php"],{chapters:4,verses:104,words:1326,chapter:{1:{verses:30,words:371},2:{verses:30,words:377},3:{verses:21,words:295},4:{verses:23,words:283}}}),R(63,66,"qwl*sy)","qwl*sy)",["Colossians","Co","Col"],{chapters:4,verses:95,words:1133,chapter:{1:{verses:29,words:356},2:{verses:23,words:283},3:{verses:25,words:284},4:{verses:18,words:210}}}),R(64,67,"). tsl*wnyqy)","). t'esol*wOnyiqoye)",["1 Thessalonians","1Th","1 Thess","1 Thes","1 Th","I Thess","I Thes","I Th","I Thessalonians","1Thess","1Thes","1Thessalonians","1st Thessalonians","1st Thess","First Thessalonians","First Thess"],{chapters:5,verses:89,words:1117,chapter:{1:{verses:10,words:139},2:{verses:20,words:299},3:{verses:13,words:171},4:{verses:18,words:240},5:{verses:28,words:268}}}),R(65,68,"b. tsl*wnyqy)","b. t'esol*wOnyiqoye)",["2 Thessalonians","2Th","2 Thess","2 Thes","2 Th","II Thess","II Thes","II Th","II Thessalonians","2Thess","2Thes","2Thessalonians","2nd Thessalonians","2nd Thess","Second Thessalonians","Second Thess"],{chapters:3,verses:47,words:609,chapter:{1:{verses:12,words:156},2:{verses:17,words:228},3:{verses:18,words:225}}}),R(66,69,"). Tymt)ws","). Tyimote)wOs",["1 Timothy","1Ti","1 Tim","1 Ti","I Ti","I Tim","I Timothy","1Tim","1Timothy","1st Timothy","1st Tim","First Timothy","First Tim"],{chapters:6,verses:113,words:1507,chapter:{1:{verses:20,words:273},2:{verses:15,words:168},3:{verses:16,words:213},4:{verses:16,words:185},5:{verses:25,words:342},6:{verses:21,words:326}}}),R(67,70,"b. Tymt)ws","b. Tyimote)wOs",["2 Timothy","2Ti","2 Tim","2 Ti","II Ti","II Tim","II Timothy","2Tim","2Timothy","2nd Timothy","2nd Tim","Second Timothy","Second Tim"],{chapters:4,verses:83,words:1040,chapter:{1:{verses:18,words:236},2:{verses:26,words:347},3:{verses:17,words:207},4:{verses:22,words:250}}}),R(68,71,"TTws","TETwOs",["Titus","Ti","Tit"],{chapters:3,verses:46,words:644,chapter:{1:{verses:16,words:245},2:{verses:15,words:178},3:{verses:15,words:221}}}),R(69,72,"pylmwn","pyilemwOn",["Philemon","Pm","Philem","Phm"],{chapters:1,verses:25,words:277,chapter:{1:{verses:25,words:277}}}),R(70,73,"(br*y)","(eb,r*oye)",["Hebrews","Hb","Heb"],{chapters:13,verses:303,words:4288,chapter:{1:{verses:14,words:187},2:{verses:18,words:264},3:{verses:19,words:225},4:{verses:16,words:242},5:{verses:14,words:209},6:{verses:20,words:252},7:{verses:28,words:404},8:{verses:13,words:224},9:{verses:28,words:454},10:{verses:39,words:487},11:{verses:40,words:585},12:{verses:29,words:434},13:{verses:25,words:321}}}),R(71,57,"y(qwb","ya(qwOb,",["James","Jm","Jas"],{chapters:5,verses:108,words:1444,chapter:{1:{verses:27,words:326},2:{verses:26,words:358},3:{verses:18,words:249},4:{verses:17,words:233},5:{verses:20,words:278}}}),R(72,58,"). k)p)","). k'e)p,o)",["1 Peter","1P","1 Pet","1 Pe","1 Pt","1 P","I Pe","I Pt","I Pet","I Peter","1Pe","1Pt","1Pet","1Peter","1st Peter","First Peter"],{chapters:5,verses:105,words:1535,chapter:{1:{verses:25,words:363},2:{verses:25,words:357},3:{verses:22,words:352},4:{verses:19,words:268},5:{verses:14,words:195}}}),R(73,74,"b. k)p)","b. k'e)p,o)",["2 Peter","2P","2 Pet","2 Pe","2 Pt","2 P","II Pe","II Pt","II Pet","II Peter","2Pet","2Pe","2Pt","2Peter","2nd Peter","Second Peter"],{chapters:3,verses:61,words:1028,chapter:{1:{verses:21,words:349},2:{verses:22,words:371},3:{verses:18,words:308}}}),R(74,59,"). ywxnn","). ywuxanon",["1 John","1J","1 Jhn","1 Jn","1 J","I Jo","I Jn","I Joh","I Jhn","I John","1Jo","1Jn","1Jhn","1Joh","1John","1st John","First John"],{chapters:5,verses:105,words:1547,chapter:{1:{verses:10,words:143},2:{verses:29,words:448},3:{verses:24,words:341},4:{verses:21,words:323},5:{verses:21,words:292}}}),R(75,75,"b. ywxnn","b. ywuxanon",["2 John","2J","2 Jhn","2 Jn","2 J","II Jo","II Jn","II Joh","II Jhn","II John","2Jo","2Jn","2Jhn","2Joh","2John","2nd John","Second John"],{chapters:1,verses:13,words:197,chapter:{1:{verses:13,words:197}}}),R(76,76,"g. ywxnn","g. ywuxanon",["3 John","3J","3 Jhn","3 Jn","3 J","3Jo","III Jo","III Jn","III Joh","III Jhn","III John","3Jn","3Jhn","3Joh","3John","3rd John","Third John"],{chapters:1,verses:15,words:211,chapter:{1:{verses:15,words:211}}}),R(77,77,"yhwd)","yihwudo)",["Jude","Jd","Jud"],{chapters:1,verses:25,words:415,chapter:{1:{verses:25,words:415}}}),R(78,78,"glyn)","g'Elyono)",["Revelation","Re","Rev","Apocalypse","Apoc"],{chapters:22,verses:404,words:6329,chapter:{1:{verses:20,words:298},2:{verses:29,words:441},3:{verses:22,words:361},4:{verses:11,words:209},5:{verses:14,words:221},6:{verses:17,words:268},7:{verses:17,words:280},8:{verses:13,words:190},9:{verses:21,words:296},10:{verses:11,words:175},11:{verses:19,words:306},12:{verses:17,words:261},13:{verses:18,words:285},14:{verses:20,words:351},15:{verses:8,words:145},16:{verses:21,words:302},17:{verses:18,words:294},18:{verses:24,words:383},19:{verses:21,words:332},20:{verses:15,words:237},21:{verses:27,words:411},22:{verses:21,words:283}}})],G=function(e,r){return e.peshittaId-r.peshittaId},W=L.slice(0).sort(G);Object.freeze(L);var H=function(e){return L[e]},_={},D=function(){if(0===Object.keys(_).length&&_.constructor===Object){for(var e=52;e<79;e++)for(var r=H(e),s=0,l=r.english.length;s<l;s++)_[r.english[s].toLowerCase()]=r;Object.freeze(_)}return _},$=[],K=[],Q=function(e,r,s){return Object.freeze(Object.create(null,{id:{value:e,enumerable:!0},name:{value:r,enumerable:!0},books:{value:s,enumerable:!0}}))},U=Object.freeze(Object.create(null,{gospels:Q("gospels","Gospels",Object.freeze(W.slice(52,56))),general:Q("general","General",Object.freeze(W.slice(56,60))),paulines:Q("paulines","Paulines",Object.freeze(W.slice(60,74))),western:Q("western","Western Five",Object.freeze(W.slice(74,79)))}));e.makeRoot=function(e,r,s){return Object.freeze(Object.create(null,{root:{value:e,enumerable:!0},sort:{value:r,enumerable:!0},attributes:{value:s,enumerable:!0}}))},e.makeRootAttribute=n,e.getRootAttribute=u,e.getRoot=function(e,r){if(r){var s=u(r.attributes);return Object.freeze(Object.create(null,{id:{value:e,enumerable:!0},root:{value:r.root,enumerable:!0},sort:{value:r.sort,enumerable:!0},seyame:{value:s.seyame,enumerable:!0},rootType:{value:s.rootType,enumerable:!0}}))}return Object.freeze(Object.create(null,{id:{value:e,enumerable:!0},root:{value:null,enumerable:!0},sort:{value:null,enumerable:!0},seyame:{value:null,enumerable:!0},rootType:{value:null,enumerable:!0}}))},e.lexemeGrammaticalCategory=t,e.lexemeFirstSuffix=v,e.lexemeSecondSuffix=d,e.lexemeThirdSuffix=m,e.lexemePrefix=i,e.lexemeRadicalType=w,e.lexemeForm=b,e.makeLexeme=function(e,r,s,l){return Object.freeze(Object.create(null,{rootId:{value:e,enumerable:!0},lexeme:{value:r,enumerable:!0},morphologicalType:{value:s,enumerable:!0},attributes:{value:l,enumerable:!0}}))},e.makeLexemeAttribute=c,e.getLexemeAttribute=h,e.makeLexemeMorphologicalType=f,e.getLexemeMorphologicalType=p,e.getLexeme=function(e,r,s){if(r){var l=h(r.attributes),a=p(r.morphologicalType);return Object.freeze(Object.create(null,{id:{value:e,enumerable:!0},rootId:{value:r.rootId,enumerable:!0},root:{value:s&&s[r.rootId]?s[r.rootId].root:null,enumerable:!0},lexeme:{value:r.lexeme,enumerable:!0},firstSuffix:{value:a.firstSuffix,enumerable:!0},secondSuffix:{value:a.secondSuffix,enumerable:!0},thirdSuffix:{value:a.thirdSuffix,enumerable:!0},prefix:{value:a.prefix,enumerable:!0},firstVowel:{value:a.firstVowel,enumerable:!0},secondVowel:{value:a.secondVowel,enumerable:!0},thirdVowel:{value:a.thirdVowel,enumerable:!0},fourthVowel:{value:a.fourthVowel,enumerable:!0},vowelCount:{value:a.vowelCount,enumerable:!0},radicalType:{value:a.radicalType,enumerable:!0},form:{value:a.form,enumerable:!0},seyame:{value:l.seyame,enumerable:!0},wordType:{value:l.wordType,enumerable:!0},grammaticalCategory:{value:l.grammaticalCategory,enumerable:!0},listing:{value:l.listing,enumerable:!0}}))}return Object.freeze(Object.create(null,{id:{value:e,enumerable:!0},rootId:{value:null,enumerable:!0},root:{value:null,enumerable:!0},lexeme:{value:null,enumerable:!0},firstSuffix:{value:null,enumerable:!0},secondSuffix:{value:null,enumerable:!0},thirdSuffix:{value:null,enumerable:!0},prefix:{value:null,enumerable:!0},firstVowel:{value:null,enumerable:!0},secondVowel:{value:null,enumerable:!0},thirdVowel:{value:null,enumerable:!0},fourthVowel:{value:null,enumerable:!0},vowelCount:{value:null,enumerable:!0},radicalType:{value:null,enumerable:!0},form:{value:null,enumerable:!0},seyame:{value:null,enumerable:!0},wordType:{value:null,enumerable:!0},grammaticalCategory:{value:null,enumerable:!0},listing:{value:null,enumerable:!0}}))},e.wordSuffixGender=y,e.wordSuffixPerson=T,e.wordSuffixNumber=g,e.wordSuffixType=x,e.wordPerson=I,e.wordState=O,e.wordTense=j,e.makeWord=function(e,r,s,l,a){return Object.freeze(Object.create(null,{lexemeId:{value:e,enumerable:!0},word:{value:r,enumerable:!0},vocalised:{value:s,enumerable:!0},morphologicalType:{value:l,enumerable:!0},attributes:{value:a,enumerable:!0}}))},e.makeWordAttribute=P,e.getWordAttribute=J,e.makeWordMorphologicalType=z,e.getWordMorphologicalType=k,e.getWord=function(e,r,s){if(r){var l=J(r.attributes),a=k(r.morphologicalType);return Object.freeze(Object.create(null,{id:{value:e,enumerable:!0},lexemeId:{value:r.lexemeId,enumerable:!0},lexeme:{value:s&&s[r.lexemeId]?s[r.lexemeId].lexeme:null,enumerable:!0},word:{value:r.word,enumerable:!0},vocalised:{value:r.vocalised,enumerable:!0},suffixGender:{value:a.suffixGender,enumerable:!0},suffixPerson:{value:a.suffixPerson,enumerable:!0},suffixNumber:{value:a.suffixNumber,enumerable:!0},suffixType:{value:a.suffixType,enumerable:!0},prefixCode:{value:a.prefixCode,enumerable:!0},gender:{value:a.gender,enumerable:!0},person:{value:a.person,enumerable:!0},number:{value:a.number,enumerable:!0},state:{value:a.state,enumerable:!0},tense:{value:a.tense,enumerable:!0},form:{value:a.form,enumerable:!0},seyame:{value:l.seyame,enumerable:!0},listing:{value:l.listing,enumerable:!0},enclitic:{value:l.enclitic,enumerable:!0},isLexeme:{value:l.lexeme,enumerable:!0}}))}return Object.freeze(Object.create(null,{id:{value:e,enumerable:!0},lexemeId:{value:null,enumerable:!0},lexeme:{value:null,enumerable:!0},word:{value:null,enumerable:!0},vocalised:{value:null,enumerable:!0},suffixGender:{value:null,enumerable:!0},suffixPerson:{value:null,enumerable:!0},suffixNumber:{value:null,enumerable:!0},suffixType:{value:null,enumerable:!0},prefixCode:{value:null,enumerable:!0},gender:{value:null,enumerable:!0},person:{value:null,enumerable:!0},number:{value:null,enumerable:!0},state:{value:null,enumerable:!0},tense:{value:null,enumerable:!0},form:{value:null,enumerable:!0},seyame:{value:null,enumerable:!0},listing:{value:null,enumerable:!0},enclitic:{value:null,enumerable:!0},isLexeme:{value:null,enumerable:!0}}))},e.textPosition=C,e.fontType=S,e.verbType=E,e.makeEnglish=function(e,r,s,l,a,o,n){return Object.freeze(Object.create(null,{lexemeId:{value:e,enumerable:!0},word:{value:r,enumerable:!0},before:{value:s,enumerable:!0},after:{value:l,enumerable:!0},comment:{value:a,enumerable:!0},attributes:{value:o,enumerable:!0},flag:{value:n,enumerable:!0}}))},e.makeEnglishAttribute=A,e.getEnglishAttribute=F,e.getEnglish=function(e,r,s){if(r){var l=F(r.attributes);return Object.freeze(Object.create(null,{id:{value:e,enumerable:!0},lexemeId:{value:r.lexemeId,enumerable:!0},lexeme:{value:s&&s[r.lexemeId]?s[r.lexemeId].lexeme:null,enumerable:!0},word:{value:r.word,enumerable:!0},before:{value:r.before,enumerable:!0},after:{value:r.after,enumerable:!0},comment:{value:r.comment,enumerable:!0},commentPosition:{value:l.commentPosition,enumerable:!0},commentFont:{value:l.commentFont,enumerable:!0},stringBeforeFont:{value:l.stringBeforeFont,enumerable:!0},stringAfterFont:{value:l.stringAfterFont,enumerable:!0},verbType:{value:l.verbType,enumerable:!0},number:{value:l.number,enumerable:!0},gender:{value:l.gender,enumerable:!0},form:{value:l.form,enumerable:!0},flag:{value:r.flag,enumerable:!0}}))}return Object.freeze(Object.create(null,{id:{value:e,enumerable:!0},lexemeId:{value:null,enumerable:!0},lexeme:{value:null,enumerable:!0},word:{value:null,enumerable:!0},before:{value:null,enumerable:!0},after:{value:null,enumerable:!0},comment:{value:null,enumerable:!0},commentPosition:{value:null,enumerable:!0},commentFont:{value:null,enumerable:!0},stringBeforeFont:{value:null,enumerable:!0},stringAfterFont:{value:null,enumerable:!0},verbType:{value:null,enumerable:!0},number:{value:null,enumerable:!0},gender:{value:null,enumerable:!0},form:{value:null,enumerable:!0},flag:{value:null,enumerable:!0}}))},e.etymologyLanguage=V,e.makeEtymology=function(e,r,s){return Object.freeze(Object.create(null,{lexemeId:{value:e,enumerable:!0},word:{value:r,enumerable:!0},attributes:{value:s,enumerable:!0}}))},e.makeEtymologyAttribute=B,e.getEtymologyAttribute=N,e.getEtymology=function(e,r,s){if(r){var l=N(r.attributes);return Object.freeze(Object.create(null,{id:{value:e,enumerable:!0},lexemeId:{value:r.lexemeId,enumerable:!0},lexeme:{value:s&&s[r.lexemeId]?s[r.lexemeId].lexeme:null,enumerable:!0},word:{value:r.word,enumerable:!0},language:{value:l.language,enumerable:!0},wordType:{value:l.wordType,enumerable:!0}}))}return Object.freeze(Object.create(null,{id:{value:e,enumerable:!0},lexemeId:{value:null,enumerable:!0},lexeme:{value:null,enumerable:!0},word:{value:null,enumerable:!0},language:{value:null,enumerable:!0},wordType:{value:null,enumerable:!0}}))},e.makeBook=M,e.books=L,e.sorter=G,e.getBook=H,e.peshittaBooks=W,e.makeBookGroup=Q,e.bookGroups=U,e.getVerseByIndex=function(e,r){for(var s=r.books-1+52,l=52;l<=s;l++){var a=r[l];if(e>=a.rollupVerses&&e<=a.rollupVerses+a.verses)for(var o=1;o<=a.chapters;o++){var n=r[l][o];if(e>=n.rollupVerses&&e<=n.rollupVerses+n.verses){var u=e-n.rollupVerses;return Object.freeze(Object.create(null,{content:{value:n[u],enumerable:!0},verse:{value:u,enumerable:!0},chapter:{value:o,enumerable:!0},book:{value:l,enumerable:!0},rollupBooks:{value:a.rollupBooks,enumerable:!0},rollupChapters:{value:n.rollupChapters,enumerable:!0},rollupVerses:{value:n.rollupVerses,enumerable:!0},rollupWords:{value:n.rollupWords,enumerable:!0}}))}}}return null},e.getIndexByVerseWoChapter=function(e,r){var s=e.book,l=e.chapter,a=e.verse,o=r[s];if(!o)return 0;var n=l&&l>0?l:1;n>o.chapters&&(n=o.chapters);var u=o[n],t=a&&a>0?a:1;return t>u.verses&&(t=u.verses),u.rollupVerses+(t-1)},e.getIndexByVerse=function(e,r){var s=e.book,l=e.chapter,a=e.verse,o=r[s];if(!o)return 0;var n=l&&l>0?l:1;n>o.chapters&&(n=o.chapters);var u=o[n],t=a&&a>0?a:0;return t>u.verses&&(t=u.verses),u.rollupChapters+u.rollupVerses+t},e.getBookByEnglish=function(e){return D()[(e||"").toLowerCase()]},e.getBooksByEnglish=D,e.getBookEnglishNames=function(){if(!$.length){for(var e=52;e<79;e++)$.push.apply($,H(e).english);$.sort(),Object.freeze($)}return $},e.getNamedReferences=function(){if(!K.length){for(var e=52;e<79;e++)for(var r=H(e),s=0,l=r.english.length;s<l;s++){var a=r.english[s],o=r.englishShortName;K.push({value:o,label:a});for(var n=1,u=r.stats.chapters;n<=u;n++){K.push({value:o+"/"+n,label:a+" "+n});for(var t=1,v=r.stats.chapter[n].verses;t<=v;t++)K.push({value:o+"/"+n+"/"+t,label:a+" "+n+":"+t})}}Object.freeze(K)}return K},Object.defineProperty(e,"__esModule",{value:!0})});
